<%@ Language=VBScript %>
<!-- #include file="shop$db.asp" -->

	<%
	' ------------------------------------------------------------------------------------------
	'  $Id: thubservice.asp$
	'  for VPASP Shopping cart

	'  Implemented by
	'  Atandra Systems
	'  www.atandra.com

	'  Copyright (c) 2007 www.atandra.com
	' ------------------------------------------------------------------------------------------

	Dim connTemp
	Dim requestInfo
	Dim requestDoc
	Dim responseDoc
	Dim requestRoot
	Dim envelopeNode
	Dim userIdNode
	Dim passwordNode
	Dim commandNode
	Dim statusCodeNode
	Dim statusMessageNode
	Dim requestIDNode
	Dim providerNode
	Dim orderCountNode
	dim noOfDaysNode
	Dim excludeOrdersNode
	Dim orderStartNumberNode
	Dim strStatusCode
	Dim strStatusMessage
	Dim strCommandValue
	Dim strRequestID
	Dim strStatus
	Dim strExcludeOrders
	Dim QB_ORDERS_PER_RESPONSE
	Dim QB_ORDER_START_NUMBER
	Dim QB_NUMBER_OF_DAYS
	Dim noOfOrdersAffected
	Dim isValidUser
	Dim strResponse
	Dim gv_cartPriceDiff
	Dim STORE_NAME
	Dim STORE_NAME_ID
	Dim conn


	requestInfo = Request.Form("request")
	Set requestDoc = Server.CreateObject("MSXML2.DOMDocument")
	If requestDoc Is Nothing Then
		Response.Write ("Unable to create XML documnet")
		Response.End
	End If

	SetSess "Login","THUB"

	requestDoc.async = False
	requestDoc.loadXML(requestInfo)
	Set requestRoot = requestDoc.documentElement
	If requestRoot Is Nothing Then
		Response.Write ("Invalid XML Request")
		Response.End
	End If

	isValidUser = False
	strCommandValue = ""
	strRequestID = ""
	QB_ORDERS_PER_RESPONSE = ""
	QB_ORDER_START_NUMBER = ""
	QB_NUMBER_OF_DAYS = ""
	strStatusCode="0"

	'Set Comment
	Set commandNode = requestRoot.selectSingleNode("/REQUEST/Command")
	If Not commandNode Is Nothing Then
		strCommandValue = commandNode.Text
	End If

	'set Request ID
	Set requestIDNode = requestRoot.selectSingleNode("/REQUEST/RequestID")
	If Not requestIDNode Is Nothing Then
		strRequestID = requestIDNode.Text
	End If

	'set Status
	Set statusNode = requestRoot.selectSingleNode("/REQUEST/Status")
	If Not statusNode Is Nothing Then
		strStatus = statusNode.Text
	End If

	Set responseDoc = Server.CreateObject("MSXML2.DOMDocument")
	Set responseDoc.documentElement = responseDoc.createElement("RESPONSE")
	responseDoc.documentElement.setAttribute "version", "1.0"
	responseDoc.documentElement.setAttribute "encoding", "ISO-8859-1"

	''''''''''''''''''''''''''''''''''''Envelope Node Ends''''''''''''''''''''''''''''''''''
		'''''''''''''''''''''''''''''''''''''Envelope Node Starts''''''''''''''''''''''''''''''''''
	'create the envelope
	Set envelopeNode = responseDoc.createElement("Envelope")
	responseDoc.documentElement.appendChild envelopeNode

	'set the command
	Set commandNode = responseDoc.createElement("Command")
	commandNode.Text = strCommandValue
	envelopeNode.appendChild commandNode

	'set the status code and message
	Set statusCodeNode = responseDoc.createElement("StatusCode")
	envelopeNode.appendChild statusCodeNode
	Set statusMessageNode = responseDoc.createElement("StatusMessage")
	envelopeNode.appendChild statusMessageNode

	'set the request id
	Set requestIDNode = responseDoc.createElement("RequestID")
	envelopeNode.appendChild requestIDNode
	requestIDNode.Text = strRequestID

	'set the provider
	Set providerNode = responseDoc.createElement("Provider")
	envelopeNode.appendChild providerNode
	providerNode.Text = "GENERIC"

	'''''''''''''''''''''''''''''''''''''Set variables to access database''''''''''''''''''''''''''''''''''
	'get the order count
	Set orderCountNode = requestRoot.selectSingleNode("/REQUEST/LimitOrderCount")
	If Not orderCountNode Is Nothing Then
		QB_ORDERS_PER_RESPONSE = orderCountNode.Text
	End If
	If QB_ORDERS_PER_RESPONSE = "" Then
		QB_ORDERS_PER_RESPONSE = 25
	End If

	'get the order count
	Set noOfDaysNode = requestRoot.selectSingleNode("/REQUEST/NumberOfDays")
	If Not noOfDaysNode Is Nothing Then
		QB_NUMBER_OF_DAYS = noOfDaysNode.Text
	End If
	If QB_NUMBER_OF_DAYS = "" Then
		QB_NUMBER_OF_DAYS = 10
	End If

	'get the start order number
	Set orderStartNumberNode = requestRoot.selectSingleNode("/REQUEST/OrderStartNumber")
	If Not orderStartNumberNode Is Nothing Then
		QB_ORDER_START_NUMBER = orderStartNumberNode.Text
	End If
	If QB_ORDER_START_NUMBER = "" Then
		QB_ORDER_START_NUMBER = 0
	End If

	Set userIdNode = requestRoot.selectSingleNode("/REQUEST/UserID")
	Set passwordNode = requestRoot.selectSingleNode("/REQUEST/Password")
	If Not userIdNode Is Nothing And Not passwordNode Is Nothing Then
		isValidUser = ValidateUser(userIdNode.Text, passwordNode.Text)
	Else
		strStatusCode = "9000"
		strStatusMessage = "Order download service authentication failure - Login/Password supplied did not match"
	End If

	If isValidUser Then
		If strCommandValue = "GetOrders" Then
			noOfOrdersAffected = Clng(GetOrders(strOrderStartNumber, strOrderCount))
	        'Response.Write("No or orders:" & noOfOrdersAffected)
			If noOfOrdersAffected = 0 Then
				strStatusCode = "1000"
				strStatusMessage = "No Orders returned"
			ElseIf noOfOrdersAffected > 0 Then
				strStatusCode = "0"
				strStatusMessage = "All OK"
				'strStatusMessage = databasetype & "/" & localDbType
			Else
				strStatusCode = "9999"
		    End If		    
		 ElseIf strCommandValue = "UpdateOrdersShippingStatus" Then
			noOfOrdersAffected = UpdateOrdersShipped(requestDoc, responseDoc)
			If noOfOrdersAffected > 0 Then
				strStatusCode = 0
				strStatusMessage = "All OK"
			Else
				strStatusCode = 9999
				strStatusMessage = "Other Error Shipped"
			End If
		End If
	Else
		strStatusCode = "9000"
	    strStatusMessage = "Login failed"
	End If

	statusCodeNode.Text = strStatusCode
	'statusCodeNode.Text = "0"
	statusMessageNode.Text = strStatusMessage

	strResponse = responseDoc.xml
	FOR asciiCode = 128 to 255
		strResponse = Replace(strResponse, Chr(asciiCode), "")
	NEXT

	Response.ContentType = "text/xml"
	Response.Write(strResponse)
	
	
	
	'''''''''''''''''''''''''''' update order shipping status function starts ''''''''''''''''
	Private Function UpdateOrdersShipped(requestDoc, responseDoc)
	
		Dim ordersNode
		Dim orderNode
		Dim requestOrderNode
		Dim childNode
		Dim requestOrderNodeList
		Dim strHostOrderId
		Dim strLocalOrderId
		Dim strLocalOrderRef
		Dim strLocalStatus
		Dim noOfOrdersUpdated
		Dim rowsAffected
		Dim trackNumber
			Dim ServiceUsed
			Dim ShippedVia
			
		noOfOrdersUpdated = 0
	
		Set requestOrderNodeList = requestDoc.getElementsByTagName("Order")
		Set ordersNode = responseDoc.createElement("Orders")
		responseDoc.documentElement.appendChild ordersNode
	
		For Each requestOrderNode In requestOrderNodeList
	
			strHostOrderId = requestOrderNode.selectSingleNode("./HostOrderID").Text
			strLocalOrderId = requestOrderNode.selectSingleNode("./LocalOrderID").Text
					trackNumber = requestOrderNode.selectSingleNode("./TrackingNumber").Text
					ServiceUsed = requestOrderNode.selectSingleNode("./ServiceUsed").Text
					ShippedVia = requestOrderNode.selectSingleNode("./ShippedVia").Text
					
					
			'If LCase(strLocalStatus) = LCase("Processed") Then
			
				rowsAffected = UpdateOrderShipped(strLocalOrderId, strHostOrderId, trackNumber, ShippedVia, ServiceUsed)
				
				Set orderNode = responseDoc.createElement("Order")
				ordersNode.appendChild orderNode
				
				'set host order id
				Set childNode = responseDoc.createElement("HostOrderID")
				orderNode.appendChild childNode
				childNode.Text = strHostOrderId
				
				'set local order id
				Set childNode = responseDoc.createElement("LocalOrderID")
				orderNode.appendChild childNode
				childNode.Text = strLocalOrderId
				
				'set local order ref
				Set childNode = responseDoc.createElement("LocalOrderRef")
				orderNode.appendChild childNode
				childNode.Text = strLocalOrderRef
				
				'set host status
				Set childNode = responseDoc.createElement("HostStatus")
				orderNode.appendChild childNode
				If rowsAffected >= 1 Then
					childNode.Text = "Success"
					noOfOrdersUpdated = noOfOrdersUpdated + rowsAffected
				Else
					childNode.Text = "Failed"
				End If
			'End If
		Next
		
		UpdateOrdersShipped = noOfOrdersUpdated
		
	End Function
	
	
	
	
	
	Private Function UpdateOrderShipped(strLocalOrderRef, strHostOrderId, trackNumber, ShippedVia, ServiceUsed)
					
	
		Dim rowsAffected
		Dim strSQL
		Dim strInsSQL
		'Dim statusFlag
		
		'If LCase(trackNumber) = LCase("BackOrder") Then
		'	statusFlag = orderBackOrderedStatus
		'Else
		'	statusFlag = orderShippedStatus
		'End If
			
		'	Dim carrierType
		'If LCase(ShippedVia) = LCase("UPS") Then
		'carrierType = "4"
		'ElseIf LCase(ShippedVia) = LCase("USPS") Then
		'	carrierType = "3"
		'ElseIf LCase(ShippedVia) = LCase("Fedex") Then
		'	carrierType = "7"
		'ElseIf LCase(ShippedVia) = LCase("DHL") Then
		'	carrierType = "8"
		'Else
		'	carrierType = "0"
		'End If
		
			
		Set cnn = Server.CreateObject("ADODB.Connection")
		ShopOpenDataBase cnn
		strSQL = "UPDATE orders SET ostatus = 'shipped' WHERE orderid = " & strHostOrderId 
		cnn.Execute strSQL, rowsAffected
		UpdateOrderShipped = rowsAffected
		cnn.Close		
		Set cnn = Nothing


        If rowsAffected >0 Then
        Set cnn = Server.CreateObject("ADODB.Connection")
		Set rs = Server.CreateObject("ADODB.RecordSet")
		ShopOpenDataBase cnn
		sqlstr = "SELECT oemail FROM orders WHERE orderid = " & strHostOrderId 
		rs.open sqlstr, cnn, 0, 1
		allDetails = rs.getrows
		set rs = nothing
		
		Dim email 
		Dim strTime
		Dim insertedRows
		email =  allDetails(0,0)
		strTime = Time()
		strInsSQL = "INSERT into ordertracking (orderid,trackcomment,trackname,trackview,trackemail,tracktime)" 
		strInsSQL = strInsSQL & "Values(" & "'"& strHostOrderId &"'," &"'"& ShippedVia & " " & ServiceUsed & " "& trackNumber  &"',"  
		strInsSQL = strInsSQL & "'Customer Service','true',"& "'"& email &"','10:42:52 AM')"
		cnn.Execute strInsSQL, insertedRows
		cnn.Close		
		Set cnn = Nothing
		
        End If


	End Function
	
	
	''''''''''''''''''''''''''''''
	

	''''''''''''''''''''''''''''''''''''' ValidateUser Function starts''''''''''''''''''''''''''''''''''
	

	
	

	Private Function getDataFromElement(e)
		dim x
		x = ""
	On error resume next
		x = Cstr(e.fields("itemname"))
		getDataFromElement =  x
	End Function
	
	Private Function ValidateUser(username, password)
		on error resume next
		Dim alladmin
		dim sqlstr
		Dim rs,cnn,allDetails





		Set cnn = Server.CreateObject("ADODB.Connection")
		Set rs = Server.CreateObject("ADODB.RecordSet")
		ShopOpenDataBase cnn
		sqlstr = "SELECT fldpassword, adminother1, uploaddirectory FROM tblUser WHERE fldusername=" & "'" & username & "'"
		rs.open sqlstr, cnn, 0, 1
		allDetails = rs.getrows
		cnn.Close
		set rs = nothing
		set cnn = nothing




		if password <> allDetails(0,0) then
			ValidateUser = False
			Exit Function
		end if

		if not allDetails(2,0) = "" then
			STORE_NAME = allDetails(2,0)
			STORE_NAME_ID = allDetails(2,0)
		else
			STORE_NAME = ""
			STORE_NAME_ID = ""
		end if

		if not allDetails(2,0) = "" then
			STORE_NAME = allDetails(2,0)
		else
			STORE_NAME = ""
		end if

				STORE_NAME = xshopid
				STORE_NAME_ID = xshopid

		ValidateUser = True

	End Function

	''''''''''''''''''''''''''''''''''''' ValidateUser Function Ends''''''''''''''''''''''''''''''''''

	Private Function GetOrders(orderStartNumber, limitOrderCount)

		Dim RequestID
		Dim StoreID
		Dim StoreName
		Dim ordersNode
		Dim orderNode
		Dim billingNode
		Dim shippingNode
		Dim creditCardNode
		Dim itemsNode
		Dim itemNode
		Dim itemOptionsNode
		Dim itemOptionNode
		Dim chargesNode
		Dim couponsNode
		Dim childNode
		Dim rsOrder
		Dim itemRS
		Dim noOfOrders
		Dim orderId
		Dim orderDateTime
		Dim orderTotal
		Dim strArray
		Dim orderCount
		Dim allOrderItem

		Set ordersNode = responseDoc.createElement("Orders")
		responseDoc.documentElement.appendChild ordersNode

		Dim tempSQLString
		Dim localDbType
		localDbType = Ucase(xdatabasetype)

	   tempSQLString = "SELECT Count(*)AS cnt FROM orders WHERE (((orders.orderid)>=" & QB_ORDER_START_NUMBER & ")"
	   if QB_ORDER_START_NUMBER = 0 then

			'SQLServer
			if localDbType="SQLSERVER"  then
				tempSQLString = tempSQLString & " AND (odate >= (DateAdd(Day,-" & QB_NUMBER_OF_DAYS & ", GETDATE())))"
			elseif localDbType="MYSQL351"  then
				tempSQLString = tempSQLString & " AND (to_days(Now()) - TO_DAYS(odate) <= " & QB_NUMBER_OF_DAYS & " )"
			else
				tempSQLString = tempSQLString & " AND (odate >= (DateAdd('d',-" & QB_NUMBER_OF_DAYS & ", Date())))"
			end if
			'to_days(Now()) - TO_DAYS(odate) 
			
	   End if
		tempSQLString = tempSQLString & " AND canceled = 0 "
		tempSQLString = tempSQLString & " and NOT (ocardtype Is NULL Or ocardtype = '') "
		tempSQLString = tempSQLString & " and NOT (ocardtype LIKE '%Declined%') "
		tempSQLString = tempSQLString & ")"
	'Response.Write(tempSQLString)
	
	  Set cnn = Server.CreateObject("ADODB.Connection")
	  Set rs = Server.CreateObject("ADODB.RecordSet")
	  ShopOpenDataBase cnn
	  alladmin = tempSQLString
	  rs.Open alladmin,cnn,0,1
	  orderCount = rs.getrows
	  cnn.Close
	  set rs = nothing
	  set cnn= nothing





	  noOfOrders = orderCount(0,0)
	'Response.Write(noOfOrders)

	  if Clng(noOfOrders) > 0 then
			set tempSQLString  = nothing
			if localDbType="SQLSERVER"  then
				tempSQLString = "SELECT Top " & QB_ORDERS_PER_RESPONSE
			elseif localDbType="MYSQL351"  then
				tempSQLString = "SELECT "
			else 
				tempSQLString = "SELECT "
			End if
			tempSQLString = tempSQLString & " o.odiscount as DiscountAmount,o.* "
			tempSQLString = tempSQLString & " FROM orders  o "
			tempSQLString = tempSQLString & " where orderid >=" & QB_ORDER_START_NUMBER
			tempSQLString = tempSQLString & " AND canceled = 0 "

			 if QB_ORDER_START_NUMBER = 0 then
					if localDbType="SQLSERVER"  then
						tempSQLString = tempSQLString & " AND (odate >= (DateAdd(d,-" & QB_NUMBER_OF_DAYS & ", GETDATE())))"
					elseif localDbType="MYSQL351"  then
						tempSQLString = tempSQLString & " AND (to_days(Now()) - TO_DAYS(odate) <= " & QB_NUMBER_OF_DAYS & " )"
					else
						tempSQLString = tempSQLString & " AND (odate >= (DateAdd('d',-" & QB_NUMBER_OF_DAYS & ", Date())))"
					end if
			 End if
			 '''''
			tempSQLString = tempSQLString & " and NOT (ocardtype Is NULL Or ocardtype = '') "
		 tempSQLString = tempSQLString & " and NOT (ocardtype LIKE '%Declined%') "
			tempSQLString = tempSQLString & " ORDER BY orderid"
			if localDbType="MYSQL351"  then
				tempSQLString = tempSQLString & " LIMIT 0, " & QB_ORDERS_PER_RESPONSE
			End if


'Response.Write(tempSQLString)
'	Response.Write(localDbType)
	
				Set cnn = Server.CreateObject("ADODB.Connection")
			Set rsOrder = Server.CreateObject("ADODB.RecordSet")
	  		ShopOpenDataBase cnn
			rsOrder.Open tempSQLString, cnn, 0, 1



			rsOrder.MoveFirst
		    while not rsOrder.EOF
		    Set orderNode = responseDoc.createElement("Order")
				   ordersNode.appendChild orderNode

				'set order id
				Set childNode = responseDoc.createElement("OrderID")
				orderNode.appendChild childNode
				if not rsOrder.fields("orderid") = "" then
					childNode.Text = rsOrder.fields("orderid")
				end if

				'set date
				Set childNode = responseDoc.createElement("Date")
				orderNode.appendChild childNode
				if not rsOrder.fields("odate") = "" then
					 orderDateTime = rsOrder.fields("odate")
					If Not IsNull(orderDateTime) Then
						childNode.Text = Year(orderDateTime) & "-" & Right(CStr(Month(orderDateTime) + 100), 2) & "-" & Right(CStr(Day(orderDateTime) + 100), 2)
					End If
				End If

				'set time
				Set childNode = responseDoc.createElement("Time")
				orderNode.appendChild childNode
				if not rsOrder.Fields("otime") = "" then
					orderDateTime= rsOrder.fields("otime")
					If Not IsNull(orderDateTime) Then
						childNode.Text = Hour(orderDateTime) & ":" & Right(CStr(Minute(orderDateTime) + 100), 2) & ":" & Right(CStr(Second(orderDateTime) + 100), 2)
					End If
				end if

				'set timezone
				Set childNode = responseDoc.createElement("TimeZone")
				orderNode.appendChild childNode
				childNode.Text = ""

				'set Store Id
				Set childNode = responseDoc.createElement("StoreId")
				orderNode.appendChild childNode
				childNode.Text = STORE_NAME_ID

				'set Store Name
				Set childNode = responseDoc.createElement("StoreName")
				orderNode.appendChild childNode
				childNode.Text = STORE_NAME

			    'set Comment
				if not rsOrder.fields("ocomment") = "" then
					Set childNode = responseDoc.createElement("Comment")
					orderNode.appendChild childNode
					childNode.Text = rsOrder.fields("ocomment")
				end if

			    'set Custom1
				if not rsOrder.fields("hearaboutus") = "" then
					Set childNode = responseDoc.createElement("CustomField1")
					orderNode.appendChild childNode
					childNode.Text = rsOrder.fields("hearaboutus")
				end if


				'set Currency
				'\this field is not version 6.0 of the site
				'if not rsOrder.fields("ocurrency") = "" then
					Set childNode = responseDoc.createElement("Currency")
					orderNode.appendChild childNode
					'childNode.Text = rsOrder.fields("ocurrency")
					childNode.Text = "USD"
				'end if

					'add billing info
					Set billingNode = responseDoc.createElement("Bill")
					orderNode.appendChild billingNode

					'Bill Node
					'set PayMethod
					Set childNode = responseDoc.createElement("PayMethod")
					billingNode.appendChild childNode
					'if not rsOrder.fields("opaymethod") = "" then
					'	childNode.Text = rsOrder.fields("opaymethod")
					'end if
					if not rsOrder.fields("ocardtype") = "" then
						childNode.Text = rsOrder.fields("ocardtype")
					end if

					Set childNode = responseDoc.createElement("PayStatus")
					billingNode.appendChild childNode
					'if not rsOrder.fields("oprocessed") = "" then
					'	 childNode.Text = rsOrder.fields("oprocessed")
					'end if
					childNode.Text = "Cleared"
					
					'set FirstName
					Set childNode = responseDoc.createElement("FirstName")
					billingNode.appendChild childNode
					if not rsOrder.fields("ofirstname") = "" then
						childNode.Text = rsOrder.fields("ofirstname")
					end if


					'Set Last Name
					Set childNode = responseDoc.createElement("LastName")
					billingNode.appendChild childNode
					if not rsOrder.fields("olastname") = "" then
						childNode.Text = rsOrder.fields("olastname")
					end if

					'Set Comapany Name
					Set childNode = responseDoc.createElement("CompanyName")
					billingNode.appendChild childNode
					if not rsOrder.fields("ocompany") = "" then
						childNode.Text = rsOrder.fields("ocompany")
					end if

					'set Address1
					Set childNode = responseDoc.createElement("Address1")
					billingNode.appendChild childNode
					if not rsOrder.fields("oaddress") = "" then
						childNode.Text = rsOrder.fields("oaddress")
					end if

					'set Address2
					Set childNode = responseDoc.createElement("Address2")
					billingNode.appendChild childNode
					if not rsOrder.fields("oaddress2") = "" then
						childNode.Text = rsOrder.fields("oaddress2")
					end if

					'set ordCity
					Set childNode = responseDoc.createElement("City")
					billingNode.appendChild childNode
					if not rsOrder.fields("ocity") = "" then
						childNode.Text = rsOrder.fields("ocity")
					end if

					'set State
					Set childNode = responseDoc.createElement("State")
					billingNode.appendChild childNode
					if not rsOrder.fields("ostate") = "" then
						childNode.Text = rsOrder.fields("ostate")
					end if

					'set ordZip
					Set childNode = responseDoc.createElement("Zip")
					billingNode.appendChild childNode
					if not rsOrder.fields("opostcode") = "" then
						childNode.Text = rsOrder.fields("opostcode")
					end if


					'set Country
					Set childNode = responseDoc.createElement("Country")
					billingNode.appendChild childNode
					if not rsOrder.fields("ocountry") = "" then
						childNode.Text = rsOrder.fields("ocountry")
					end if

					'set Email
					Set childNode = responseDoc.createElement("Email")
					billingNode.appendChild childNode
					if not rsOrder.fields("oemail") = "" then
						childNode.Text = rsOrder.fields("oemail")
					end if

					'set Phone
					Set childNode = responseDoc.createElement("Phone")
					billingNode.appendChild childNode
					if not rsOrder.fields("ophone") = "" then
						childNode.Text = rsOrder.fields("ophone")
					end if

					'set CreditCard
					if rsOrder.fields("ocardname") <> "" then

						Set creditCardNode = responseDoc.createElement("CreditCard")
						billingNode.appendChild creditCardNode

						'set CreditCardType
						Set childNode = responseDoc.createElement("CreditCardType")
						creditCardNode.appendChild childNode
						if not rsOrder.fields("ocardtype") = "" then
							childNode.Text = rsOrder.fields("ocardtype")
						end if

						'set CreditCardCharge
						Set childNode = responseDoc.createElement("CreditCardCharge")
						creditCardNode.appendChild childNode
						if not rsOrder.fields("orderamount") = "" then
							childNode.Text = rsOrder.fields("orderamount")
						end if


						'set ExpirationDate
						Set childNode = responseDoc.createElement("ExpirationDate")
						creditCardNode.appendChild childNode
						if not rsOrder.fields("ocardexpires") = "" then
							childNode.Text = rsOrder.fields("ocardexpires")
						end if

						'set CreditCardName
						Set childNode = responseDoc.createElement("CreditCardName")
						creditCardNode.appendChild childNode
						if not rsOrder.fields("ocardname") = "" then
							childNode.Text = rsOrder.fields("ocardname")
						end if

						'set CreditCardNumber
				'		Set childNode = responseDoc.createElement("CreditCardNumber")
				'		creditCardNode.appendChild childNode
				'		if not rsOrder.fields("ocardno") = "" then
				'			childNode.Text = rsOrder.fields("ocardno")
				'		end if

						'set AuthDetails
						Set childNode = responseDoc.createElement("AuthDetails")
						creditCardNode.appendChild childNode
						if not rsOrder.fields("oauthorization") = "" then
							childNode.Text = rsOrder.fields("oauthorization")
						end if

					end if

				'add shipping info
				Set shippingNode = responseDoc.createElement("Ship")
				orderNode.appendChild shippingNode

				'set ShipMethod
				Set childNode = responseDoc.createElement("ShipMethod")
				shippingNode.appendChild childNode
				if not rsOrder.fields("oshipmethodtype") = "" then
					 childNode.Text = rsOrder.fields("oshipmethodtype")
				end if



			Dim arrLen
			Dim sfirstName
		  Dim slastName


				'Set first name
				Set childNode = responseDoc.createElement("FirstName")
				shippingNode.appendChild childNode
				if not rsOrder.fields("oshipname") = "" then				
						strArray = Split(rsOrder.fields("oshipname"), " ", -1)
						arrLen = Ubound(strArray)
						if arrLen > 1 then
							sfirstName=strArray(0) & " " & strArray(1)
						else
							sfirstName=strArray(0)
						end if
						childNode.Text = sfirstName 
				else
					if not rsOrder.fields("ofirstname") = "" then
						 childNode.Text = rsOrder.fields("ofirstname")
					else
							childNode.Text = ""
					end if
				end if		    

				'Set Last name
				Set childNode = responseDoc.createElement("LastName")
				shippingNode.appendChild childNode
				if not rsOrder.fields("oshipname") = "" then				
					slastName = Replace(rsOrder.fields("oshipname"),sfirstName,"")
					childNode.Text = slastName	
				else
					if not rsOrder.fields("olastname") = "" then
						 childNode.Text = rsOrder.fields("olastname")
					else
							childNode.Text = ""
					end if
				end if
				set strArray = Nothing
				
				
				'Set Comapany Name
					Set childNode = responseDoc.createElement("CompanyName")
					shippingNode.appendChild childNode
					if not rsOrder.fields("oshipcompany") = "" then
						childNode.Text = rsOrder.fields("oshipcompany")
					end if


				'set Address1
				Set childNode = responseDoc.createElement("Address1")
				shippingNode.appendChild childNode
				if not rsOrder.fields("oshipaddress") = "" then
					childNode.Text = rsOrder.fields("oshipaddress")
				end if





				'set Address2
				Set childNode = responseDoc.createElement("Address2")
				shippingNode.appendChild childNode
				if not rsOrder.fields("oshipaddress2") = "" then
					childNode.Text = rsOrder.fields("oshipaddress2")
				end if
				'childNode.Text  =""

				'set City
				Set childNode = responseDoc.createElement("City")
				shippingNode.appendChild childNode
				if not rsOrder.fields("oshiptown") = "" then
					childNode.Text = rsOrder.fields("oshiptown")
				end if

				'set State
				Set childNode = responseDoc.createElement("State")
				shippingNode.appendChild childNode
				if not rsOrder.fields("oshipstate") = "" then
					childNode.Text = rsOrder.fields("oshipstate")
				end if

				'set Zip
				Set childNode = responseDoc.createElement("Zip")
				shippingNode.appendChild childNode
				if not rsOrder.fields("oshipzip") = "" then
					childNode.Text = rsOrder.fields("oshipzip")
				end if

				'set Country
				Set childNode = responseDoc.createElement("Country")
				shippingNode.appendChild childNode
				if not rsOrder.fields("oshipcountry") = "" then
					childNode.Text = rsOrder.fields("oshipcountry")
				end if

				'set Email
				Set childNode = responseDoc.createElement("Email")
				shippingNode.appendChild childNode
				if not rsOrder.fields("oemail") = "" then
					childNode.Text = rsOrder.fields("oemail")
				end if

				'set Phone
				Set childNode = responseDoc.createElement("Phone")
				shippingNode.appendChild childNode
				if not rsOrder.fields("ophone") = "" then
					childNode.Text = rsOrder.fields("ophone")
				end if


					'Get Items
				    ''----------------------START--------------------------
					Dim itemQry, ispWeight
					Set allOrderItem = Server.CreateObject("ADODB.RecordSet")
					'itemQry = "SELECT * FROM oitems WHERE orderid = " & rsOrder.fields("orderid")
					itemQry = "select i.numitems,	i.itemname,	i.unitprice,	i.dualprice, p.ccode, p.cname, p.weight from oitems as i, products as p WHERE i.catalogid = p.catalogid AND i.orderid = " & rsOrder.fields("orderid")

'Response.Write(itemQry)

					allOrderItem.Open itemQry, cnn, 0, 1



					Set itemsNode = responseDoc.createElement("Items")
					orderNode.appendChild itemsNode
					
					if not allOrderItem.EOF then
						allOrderItem.MoveFirst
					end if
					
					while not allOrderItem.EOF
						Set itemNode = responseDoc.createElement("Item")
						itemsNode.appendChild itemNode

						Set itemOptionsNode = responseDoc.createElement("ItemOptions")
						itemNode.appendChild itemOptionsNode

						'set item code
						Set childNode = responseDoc.createElement("ItemCode")
						itemNode.appendChild childNode
						if not allOrderItem.fields("ccode") = "" then
							childNode.Text = allOrderItem.fields("ccode")
						end if

						'set ItemDescription
						Dim itemDesc
						itemDesc = getDataFromElement(allOrderItem)
						Set childNode = responseDoc.createElement("ItemDescription")
						itemNode.appendChild childNode
						childNode.Text = itemDesc

						'set Quantity
						Set childNode = responseDoc.createElement("Quantity")
						itemNode.appendChild childNode
						if not allOrderItem.fields("numitems") = "" then
							childNode.Text = allOrderItem.fields("numitems")
						end if

						'set UnitPrice
						Set childNode = responseDoc.createElement("UnitPrice")
						itemNode.appendChild childNode
						if not allOrderItem.fields("unitprice") = "" then
							childNode.Text = allOrderItem.fields("unitprice")
						end if

						Set childNode = responseDoc.createElement("ItemUnitWeight")
						itemNode.appendChild childNode
						if not allOrderItem.fields("weight") = "" then
							childNode.Text = Cint(allOrderItem.fields("weight"))
						end if



						allOrderItem.MoveNext
					Wend
					''----------------------END----------------------------

				'add charges
				Set chargesNode = responseDoc.createElement("Charges")
				orderNode.appendChild chargesNode

				'set Shipping
				Set childNode = responseDoc.createElement("Shipping")
				chargesNode.appendChild childNode
				if not rsOrder.fields("oshipcost") = "" then
					childNode.Text = rsOrder.fields("oshipcost")
				end if

				'set Handling
				Set childNode = responseDoc.createElement("Handling")
				chargesNode.appendChild childNode
				if not rsOrder.fields("ohandling") = "" then
					childNode.Text = rsOrder.fields("ohandling")
				end if

				'set Tax
				Set childNode = responseDoc.createElement("Tax")
				chargesNode.appendChild childNode
				if not rsOrder.fields("otax") = "" then
					childNode.Text = rsOrder.fields("otax")
				end if

				'set Tax
				Set childNode = responseDoc.createElement("TaxOther")
				chargesNode.appendChild childNode
				if not rsOrder.fields("odualtaxes") = "" then
					childNode.Text = rsOrder.fields("odualtaxes")
				end if

				'set Discount
				Set childNode = responseDoc.createElement("Discount")
				chargesNode.appendChild childNode
				if not rsOrder.fields("odiscount") = "" then
					childNode.Text = rsOrder.fields("odiscount")
				end if

				'set Discount
				Set childNode = responseDoc.createElement("GiftCertificate")
				chargesNode.appendChild childNode
				if not rsOrder.fields("giftcertificate") = "" then
					childNode.Text = rsOrder.fields("giftcertificate")
				end if

				'set Discount
				Set childNode = responseDoc.createElement("OtherCharge")
				chargesNode.appendChild childNode
				if not rsOrder.fields("giftamountused") = "" then
					childNode.Text = rsOrder.fields("giftamountused")
				end if

				dim certificateAmount
				if(not rsOrder.fields("giftamountused")="") then
					certificateAmount= cdbl(rsOrder.fields("giftamountused"))
				end if

				'set Total
				Set childNode = responseDoc.createElement("Total")
				chargesNode.appendChild childNode
				childNode.Text = Round(CDbl(rsOrder.fields("orderamount")),2)

				'add charges
				Set chargesNode = responseDoc.createElement("Coupon")
				orderNode.appendChild chargesNode

				'set CouponCode
				Set childNode = responseDoc.createElement("CouponCode")
				chargesNode.appendChild childNode
				if not rsOrder.fields("coupon") = "" then
					childNode.Text = rsOrder.fields("coupon")
				end if

			    'set CouponID
				Set childNode = responseDoc.createElement("CouponID")
				chargesNode.appendChild childNode
				if not rsOrder.fields("coupon") = "" then
					childNode.Text = rsOrder.fields("coupon")
				end if

				rsOrder.MoveNext
		    wend

		    cnn.close
		    set cnn=nothing
			set rsOrders = nothing
			set allOrderItem = nothing
	 End If


		'Response.Write(tempSQLString)
		'Response.Write("<br>")
		'Response.Write(ucase(strStatus))
		'Response.Write("<br>")
		'Response.Write(noOfOrders)
	GetOrders = noOfOrders
	
	
	
	
End Function

%>